#include <stdio.h>
#include <InterfaceKit.h>
#include "Preferences.h"

Preferences ThePrefs;

const char* Preferences::kDefSettingsFolderName= "/boot/home/config/settings/CL-Amp";
static const char* PrefsFileName = "DSPPlugin_Equalizer.preferences";

void Preferences::SetDefData()
{
	for (int i = 0; i < 10; i++)
		fPD.gain[i] = 0;
}

void Preferences::SetGain(uint8 band, int8 g)
{
	fPD.gain[band] = g;
	fPrefsChanged = true;
}

Preferences::Preferences()
	: fPrefsChanged(false)
{
	if ((fDataSemaphore = create_sem(1, "Preferences")) != B_NO_ERROR);
		fSettingsFolderName = NULL;

	SetDefData();
}

bool Preferences::PrefsChanged()
{
	bool res = fPrefsChanged;
	fPrefsChanged = false;
	return res;
}

void Preferences::Init(const char *SettingsFolder)
{
	char	Line[B_FILE_NAME_LENGTH];
	FILE*	f;

	fSettingsFolderName = SettingsFolder;
	SetDefData();

	if (NULL != (f = fopen(SettingsFileName(Line, PrefsFileName), "r")))
	{
		fread(&fPD, 1, sizeof(fPD), f);
		fclose(f);
	}
}

Preferences::~Preferences()
{
	char	Line[B_FILE_NAME_LENGTH];
	FILE*	f;

	if (NULL != (f = fopen(SettingsFileName(Line, PrefsFileName), "w")))
	{
		if (sizeof(fPD) != fwrite(&fPD, 1, sizeof(fPD), f));
		fclose(f);
	}

	delete_sem(fDataSemaphore);
}

const char* Preferences::SettingsFileName(char* buff, const char* fName)
{
	sprintf(buff, "%s/%s", SettingsFolder(), fName);

	return buff;
}
