#ifndef CL_PREFERENCES_H
#define CL_PREFERENCES_H

struct prefs_data {
	int8 gain[10];
};

class Preferences {
public:
			Preferences();
			~Preferences();

	void	Init(const char* SettingsFolder);

	bool 	Lock()		{ return (B_NO_ERROR == acquire_sem(fDataSemaphore)); }
	void	Unlock()	{ release_sem(fDataSemaphore); }

	bool	LockButDontWait() {
		return (B_NO_ERROR == acquire_sem_etc(fDataSemaphore, 1, B_TIMEOUT, 0));
	}

	void	SetGain(uint8 band, int8 g);
	int8	Gain(uint8 band)			{ return fPD.gain[band]; }

	bool	PrefsChanged();

	const char* SettingsFolder()
	{
		return (fSettingsFolderName ? fSettingsFolderName : kDefSettingsFolderName);
	}

	const char* SettingsFileName(char* Buff, const char* FName);

private:
	void	SetDefData();

	bool	fPrefsChanged;

	struct prefs_data	fPD;
	const char*			fSettingsFolderName;
	sem_id				fDataSemaphore;
	static const char*	kDefSettingsFolderName;
};

extern Preferences ThePrefs;

#endif
